SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell methodsFor: 'initialization' stamp: 'ik 6/28/2015 15:00'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds:= 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!SBECell methodsFor: 'accessing' stamp: 'ik 6/28/2015 16:49'!
mouseAction: aBlock 
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'ik 6/28/2015 16:56'!
mouseUp: anEvent 
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'initialization' stamp: 'ik 6/28/2015 15:45'!
cellsPerSide
	^ 10! !

!SBEGame methodsFor: 'initialization' stamp: 'ik 6/28/2015 15:40'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'initialization' stamp: 'ik 7/20/2015 14:05'!
newCellAt: i at: j 
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: i - 1 * c width @ (j - 1 * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
 	^ c! !

!SBEGame methodsFor: 'game logic' stamp: 'ik 7/20/2015 14:07'!
toggleNeighboursOfCellAt: i at: j 
	i > 1
		ifTrue: [(cells at: i - 1 at: j) toggleState].
	i < self cellsPerSide
		ifTrue: [(cells at: i + 1 at: j) toggleState].
	j > 1
		ifTrue: [(cells at: i at: j - 1) toggleState].
	j < self cellsPerSide
		ifTrue: [(cells at: i at: j + 1) toggleState]! !
